/**
 * Eine Verkehrsampel.
 * 
 * @author 10c 
 * @version 2014-11-28
 */
public class Ampel
{
    // Der Ampelzustand.
    // 'H': "Halt", d. h. rot;
    // 'B': "Bereit", d. h. rot und gelb;
    // 'F': "Fahrt", d. h. grn;
    // 'A': "Achtung", d. h. gelb.
    private char zustand;

    // Ein Gehuse und die drei Ampellichter als Referenzattribute.
    private Rechteck gehaeuse;
    private Kreissektor licht1;
    private Kreissektor licht2;
    private Kreissektor licht3;

    // Ein weiteres Gehuse und zwei Ampellichter fr die Fugngerampel.
    private Rechteck fussgehaeuse;
    private Kreissektor fusslicht1;
    private Kreissektor fusslicht2;

    /**
     * Konstruktor.
     * Erzeuge links oben auf der Leinwand eine Ampel und
     * eine Fugngerampel, bei denen die Lichter den
     * angegebenen Radius und den angegebenen Abstand
     * untereinander und vom jeweiligen Gehuse haben.
     * Schalte sie in den Haltezustand 'H'.
     */
    public Ampel (int lichtradius, int abstand)
    {
        zustand = 'H';

        gehaeuse = new Rechteck ();
        gehaeuse.setzeBreite (2*lichtradius + 2*abstand);
        gehaeuse.setzeHoehe (6*lichtradius + 4*abstand);
        gehaeuse.setzeFarbe ("grau");

        licht1 = new Kreissektor ();
        licht1.setzePosition (abstand, abstand);
        licht1.setzeGesamtwinkel (360);
        licht1.setzeRadius (lichtradius);

        licht2 = new Kreissektor ();
        licht2.setzePosition (abstand, 2*lichtradius + 2*abstand);
        licht2.setzeGesamtwinkel (360);
        licht2.setzeRadius (lichtradius);

        licht3 = new Kreissektor ();
        licht3.setzePosition (abstand, 4*lichtradius + 3*abstand);
        licht3.setzeGesamtwinkel (360);
        licht3.setzeRadius (lichtradius);

        fussgehaeuse = new Rechteck ();
        fussgehaeuse.setzePosition (2*lichtradius + 4*abstand, 2*lichtradius + abstand);
        fussgehaeuse.setzeBreite (2*lichtradius + 2*abstand);
        fussgehaeuse.setzeHoehe (4*lichtradius + 3*abstand);
        fussgehaeuse.setzeFarbe ("grau");

        fusslicht1 = new Kreissektor ();
        fusslicht1.setzePosition (2*lichtradius + 5*abstand, 2*lichtradius + 2*abstand);
        fusslicht1.setzeGesamtwinkel (360);
        fusslicht1.setzeRadius (lichtradius);

        fusslicht2 = new Kreissektor ();
        fusslicht2.setzePosition (2*lichtradius + 5*abstand, 4*lichtradius + 3*abstand);
        fusslicht2.setzeGesamtwinkel (360);
        fusslicht2.setzeRadius (lichtradius);

        zeichne ();
    }

    /**
     * Schalte die Ampel in ihren nchsten Zustand.
     * Die Zustandsreihenfolge ist "Halt", "Bereit",
     * "Fahrt" und "Achtung" (also rot, rot und gelb,
     * grn, gelb).
     */
    public void schalteUm ()
    {
        switch (zustand)
        {
            case 'H': zustand = 'B'; break;
            case 'B': zustand = 'F'; break;
            case 'F': zustand = 'A'; break;
            case 'A': zustand = 'H'; break;
        }

        zeichne ();
    }

    /**
     * Zeichne die Ampel in den Farben ihres
     * augenblicklichen Zustands.
     */
    private void zeichne ()
    {
        switch (zustand)
        {
            case 'H':
            licht1.setzeFarbe ("rot");
            licht2.setzeFarbe ("schwarz");
            licht3.setzeFarbe ("schwarz");
            fusslicht1.setzeFarbe ("schwarz");
            fusslicht2.setzeFarbe ("gruen");
            break;

            case 'B':
            licht1.setzeFarbe ("rot");
            licht2.setzeFarbe ("gelb");
            licht3.setzeFarbe ("schwarz");
            fusslicht1.setzeFarbe ("rot");
            fusslicht2.setzeFarbe ("schwarz");
            break;

            case 'F':
            licht1.setzeFarbe ("schwarz");
            licht2.setzeFarbe ("schwarz");
            licht3.setzeFarbe ("gruen");
            fusslicht1.setzeFarbe ("rot");
            fusslicht2.setzeFarbe ("schwarz");
            break;

            case 'A':
            licht1.setzeFarbe ("schwarz");
            licht2.setzeFarbe ("gelb");
            licht3.setzeFarbe ("schwarz");
            fusslicht1.setzeFarbe ("rot");
            fusslicht2.setzeFarbe ("schwarz");
            break;
        }
    }
}